N = 15;
result_imw = 1000;
result_imh = 1000;

samples = zeros(result_imw,result_imh,3,N+1);

I0 = imread('0.jpg');

H = [1 0 200; 0 1 280; 0 0 1];
tform = maketform('projective',H');
Base = imtransform(I0,tform,'nearest','xyscale',1,...
                'xdata', [1 result_imw], 'ydata', [1 result_imh],...
                'fillvalues', 0);
samples(:,:,:,1) = Base;
            
for sample_num = 1:N  
    
    clear current_I;
    clear tform;
    clear Base_tmp;
    
    im_name=sprintf('%d.jpg',sample_num);
    current_I=imread(im_name);
    tform = auto(current_I,Base);
    Base_tmp = imtransform(current_I,tform,'nearest','xyscale',1,...
                'xdata', [1 result_imw], 'ydata', [1 result_imh],...
                'fillvalues', 0);
    samples(:,:,:,sample_num+1) = Base_tmp;
    
end

masks = (samples>0);
masks = double(masks);

total = sum(samples,4);
valid_pixel_nb = sum(masks,4);
average_im = total./ valid_pixel_nb;
average_im(isnan(average_im))=0;

average_im = uint8(average_im);


simple_median = median(samples,4);
simple_median = uint8(simple_median);


precise_median = zeros(result_imh,result_imw,3);
for color = 1:3
    for y=1 : result_imh
        for x = 1:result_imw
            clear valid_values;
            valid_values = samples(y,x,color,samples(y,x,color,:)>0);
            precise_median(y,x,color) = median(valid_values);
        end
    end
end
precise_median(isnan(precise_median)) = 0;
precise_median = uint8(precise_median);