imh = result_imh;
imw = result_imw;
direction = 4;

gradient = NaN(imh,imw,direction,3,N+1); %direction: 1-up,2-down,3-left,4-right

masks = (samples>0);

for sample_num = 1:N+1
    for color = 1:3
        for x=1:imw
            for y=1:imh
                if masks(y,x,color,sample_num)
                    if y>1 && masks(y-1,x,color,sample_num)
                        gradient(y,x,1,color,sample_num) = samples(y,x,color,sample_num)-...
                            samples(y-1,x,color,sample_num);
                    end
                    if y<imh && masks(y+1,x,color,sample_num)
                        gradient(y,x,2,color,sample_num) = samples(y,x,color,sample_num)-...
                            samples(y+1,x,color,sample_num);
                    end
                    if x>1 && masks(y,x-1,color,sample_num)
                        gradient(y,x,3,color,sample_num) = samples(y,x,color,sample_num)-...
                            samples(y,x-1,color,sample_num);
                    end
                    if x<imw && masks(y,x+1,color,sample_num)
                        gradient(y,x,4,color,sample_num) = samples(y,x,color,sample_num)-...
                            samples(y,x+1,color,sample_num);
                    end
                end
            end
        end
    end
end

gradient_masks = not(isnan(gradient));
valid_gradient = any(gradient_masks,5);
valid_point = any(valid_gradient,3);

gradient_masks = double(gradient_masks);
gradient(isnan(gradient)) = 0;
total_gradient_masks = sum(gradient_masks,5);
total_gradient = sum(gradient,5);

average_gradient = total_gradient./total_gradient_masks;

im2var = zeros(imh, imw); 
im2var(1:imh*imw) = 1:imh*imw; 

output = zeros(imh,imw,3);
output = double(output);



   
for color=1:3
    clear b;
    clear i;
    clear j;
    clear va;
    b = zeros(1,imh*imw);
    i = zeros(1,imh*imw);
    j = zeros(1,imh*imw);
    va = zeros(1,imh*imw);
    
    sparse_count = 0;
    e = 0;
    for y=1:imh
        for x=1:imw
            if y==uint32(imh/2) && x==uint32(imw/2)
                e = e+1;
                sparse_count = sparse_count+1;
                i(sparse_count) = e;
                j(sparse_count) = im2var(y,x);
                va(sparse_count) = 1;
                b(e) = average_im(y,x,color);
            else
                if valid_point(y,x,color)
                    e = e+1;
                    sparse_count = sparse_count+1;
                    center_sc = sparse_count;
                    i(sparse_count) = e;
                    j(sparse_count) = im2var(y,x);
                    va(sparse_count) = 0;
                    if valid_gradient(y,x,1,color)
                        sparse_count = sparse_count+1;
                        i(sparse_count) = e;
                        j(sparse_count) = im2var(y-1,x);
                        va(sparse_count) = -1;
                        va(center_sc) = va(center_sc)+1;
                        b(e) = b(e)+average_gradient(y,x,1,color);
                    end
                    if valid_gradient(y,x,2,color)
                        sparse_count = sparse_count+1;
                        i(sparse_count) = e;
                        j(sparse_count) = im2var(y+1,x);
                        va(sparse_count) = -1;
                        va(center_sc) = va(center_sc)+1;
                        b(e) = b(e)+average_gradient(y,x,2,color);
                    end
                    if valid_gradient(y,x,3,color)
                        sparse_count = sparse_count+1;
                        i(sparse_count) = e;
                        j(sparse_count) = im2var(y,x-1);
                        va(sparse_count) = -1;
                        va(center_sc) = va(center_sc)+1;
                        b(e) = b(e)+average_gradient(y,x,3,color);
                    end
                    if valid_gradient(y,x,4,color)
                        sparse_count = sparse_count+1;
                        i(sparse_count) = e;
                        j(sparse_count) = im2var(y,x+1);
                        va(sparse_count) = -1;
                        va(center_sc) = va(center_sc)+1;
                        b(e) = b(e)+average_gradient(y,x,4,color);
                    end                   
                else
                    e = e+1;
                    sparse_count = sparse_count+1;
                    i(sparse_count) = e;
                    j(sparse_count) = im2var(y,x);
                    va(sparse_count) = 1;
                    b(e) = 0;
                end
            end
        end
    end
   
    A = sparse(i,j,va,imh*imw,imh*imw);
    b=b(:);

    clear v;
    v = A\b;
    
    clear temp;
    temp = zeros(imh,imw);
    temp = double(temp);
    temp(:)=v;
    output(:,:,color) = temp;
end

output = uint8(output);

